org.apache.poi.hwpf.model.types

## Class TAPAbstractType

- java.lang.Object
- - org.apache.poi.hwpf.model.types.TAPAbstractType

- Direct Known Subclasses:
    TableProperties

      @Internal
      public abstract class TAPAbstractType
      extends java.lang.Object

  Table Properties

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected short` | `field_1_istd`
    `protected short` | `field_10_wWidthIndent`
    `protected short` | `field_11_wWidthBefore`
    `protected short` | `field_12_wWidthAfter`
    `protected int` | `field_13_widthAndFitsFlags`
    `protected int` | `field_14_dxaAbs`
    `protected int` | `field_15_dyaAbs`
    `protected int` | `field_16_dxaFromText`
    `protected int` | `field_17_dyaFromText`
    `protected int` | `field_18_dxaFromTextRight`
    `protected int` | `field_19_dyaFromTextBottom`
    `protected short` | `field_2_jc`
    `protected byte` | `field_20_fBiDi`
    `protected byte` | `field_21_fRTL`
    `protected byte` | `field_22_fNoAllowOverlap`
    `protected byte` | `field_23_fSpare`
    `protected int` | `field_24_grpfTap`
    `protected int` | `field_25_internalFlags`
    `protected short` | `field_26_itcMac`
    `protected int` | `field_27_dxaAdjust`
    `protected int` | `field_28_dxaWebView`
    `protected int` | `field_29_dxaRTEWrapWidth`
    `protected int` | `field_3_dxaGapHalf`
    `protected int` | `field_30_dxaColWidthWwd`
    `protected short` | `field_31_pctWwd`
    `protected int` | `field_32_viewFlags`
    `protected short[]` | `field_33_rgdxaCenter`
    `protected short[]` | `field_34_rgdxaCenterPrint`
    `protected ShadingDescriptor` | `field_35_shdTable`
    `protected BorderCode` | `field_36_brcBottom`
    `protected BorderCode` | `field_37_brcTop`
    `protected BorderCode` | `field_38_brcLeft`
    `protected BorderCode` | `field_39_brcRight`
    `protected int` | `field_4_dyaRowHeight`
    `protected BorderCode` | `field_40_brcVertical`
    `protected BorderCode` | `field_41_brcHorizontal`
    `protected short` | `field_42_wCellPaddingDefaultTop`
    `protected short` | `field_43_wCellPaddingDefaultLeft`
    `protected short` | `field_44_wCellPaddingDefaultBottom`
    `protected short` | `field_45_wCellPaddingDefaultRight`
    `protected byte` | `field_46_ftsCellPaddingDefaultTop`
    `protected byte` | `field_47_ftsCellPaddingDefaultLeft`
    `protected byte` | `field_48_ftsCellPaddingDefaultBottom`
    `protected byte` | `field_49_ftsCellPaddingDefaultRight`
    `protected boolean` | `field_5_fCantSplit`
    `protected short` | `field_50_wCellSpacingDefaultTop`
    `protected short` | `field_51_wCellSpacingDefaultLeft`
    `protected short` | `field_52_wCellSpacingDefaultBottom`
    `protected short` | `field_53_wCellSpacingDefaultRight`
    `protected byte` | `field_54_ftsCellSpacingDefaultTop`
    `protected byte` | `field_55_ftsCellSpacingDefaultLeft`
    `protected byte` | `field_56_ftsCellSpacingDefaultBottom`
    `protected byte` | `field_57_ftsCellSpacingDefaultRight`
    `protected short` | `field_58_wCellPaddingOuterTop`
    `protected short` | `field_59_wCellPaddingOuterLeft`
    `protected boolean` | `field_6_fCantSplit90`
    `protected short` | `field_60_wCellPaddingOuterBottom`
    `protected short` | `field_61_wCellPaddingOuterRight`
    `protected byte` | `field_62_ftsCellPaddingOuterTop`
    `protected byte` | `field_63_ftsCellPaddingOuterLeft`
    `protected byte` | `field_64_ftsCellPaddingOuterBottom`
    `protected byte` | `field_65_ftsCellPaddingOuterRight`
    `protected short` | `field_66_wCellSpacingOuterTop`
    `protected short` | `field_67_wCellSpacingOuterLeft`
    `protected short` | `field_68_wCellSpacingOuterBottom`
    `protected short` | `field_69_wCellSpacingOuterRight`
    `protected boolean` | `field_7_fTableHeader`
    `protected byte` | `field_70_ftsCellSpacingOuterTop`
    `protected byte` | `field_71_ftsCellSpacingOuterLeft`
    `protected byte` | `field_72_ftsCellSpacingOuterBottom`
    `protected byte` | `field_73_ftsCellSpacingOuterRight`
    `protected TableCellDescriptor[]` | `field_74_rgtc`
    `protected ShadingDescriptor[]` | `field_75_rgshd`
    `protected byte` | `field_76_fPropRMark`
    `protected byte` | `field_77_fHasOldProps`
    `protected short` | `field_78_cHorzBands`
    `protected short` | `field_79_cVertBands`
    `protected TableAutoformatLookSpecifier` | `field_8_tlp`
    `protected BorderCode` | `field_80_rgbrcInsideDefault_0`
    `protected BorderCode` | `field_81_rgbrcInsideDefault_1`
    `protected short` | `field_9_wWidth`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `TAPAbstractType()`
    `protected` | `TAPAbstractType(TAPAbstractType other)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `BorderCode` | `getBrcBottom()` Get the brcBottom field for the TAP record.
    `BorderCode` | `getBrcHorizontal()` Get the brcHorizontal field for the TAP record.
    `BorderCode` | `getBrcLeft()` Get the brcLeft field for the TAP record.
    `BorderCode` | `getBrcRight()` Get the brcRight field for the TAP record.
    `BorderCode` | `getBrcTop()` Get the brcTop field for the TAP record.
    `BorderCode` | `getBrcVertical()` Get the brcVertical field for the TAP record.
    `short` | `getCHorzBands()` Size of each horizontal style band, in number of rows.
    `short` | `getCVertBands()` Size of a vertical style band, in number of columns.
    `int` | `getDxaAbs()` Absolute horizontal position.
    `int` | `getDxaAdjust()` Used internally by Word.
    `int` | `getDxaColWidthWwd()` Used internally by Word.
    `int` | `getDxaFromText()` Left distance from surrounding text when absolutely positioned.
    `int` | `getDxaFromTextRight()` Right distance from surrounding text when absolutely positioned.
    `int` | `getDxaGapHalf()` Measures half of the white space that will be maintained between text in adjacent columns of a table row.
    `int` | `getDxaRTEWrapWidth()` Used internally by Word.
    `int` | `getDxaWebView()` Used internally by Word.
    `int` | `getDyaAbs()` Absolute vertical position.
    `int` | `getDyaFromText()` Top distance from surrounding text when absolutely positioned.
    `int` | `getDyaFromTextBottom()` Bottom distance from surrounding text when absolutely positioned.
    `int` | `getDyaRowHeight()` When greater than 0, guarantees that the height of the table will be at least dyaRowHeight high.
    `byte` | `getFBiDi()` When 1, table is right-to-left.
    `boolean` | `getFCantSplit()` When 1, table row may not be split across page bounds.
    `boolean` | `getFCantSplit90()` When 1, table row may not be split across page bounds.
    `byte` | `getFHasOldProps()` Has old properties.
    `byte` | `getFNoAllowOverlap()` When set to 1, do not allow absolutely positioned table to overlap with other tables.
    `byte` | `getFPropRMark()` Set to 1 if property revision.
    `byte` | `getFRTL()` Word 2000 style right-to-left table.
    `byte` | `getFSpare()` Not used.
    `boolean` | `getFTableHeader()` When 1, table row is to be used as the header of the table.
    `byte` | `getFtsCellPaddingDefaultBottom()` Default bottom cell margin/padding units.
    `byte` | `getFtsCellPaddingDefaultLeft()` Default left cell margin/padding units.
    `byte` | `getFtsCellPaddingDefaultRight()` Default right cell margin/padding units.
    `byte` | `getFtsCellPaddingDefaultTop()` Default top cell margin/padding units.
    `byte` | `getFtsCellPaddingOuterBottom()` Default outer bottom cell margin/padding units.
    `byte` | `getFtsCellPaddingOuterLeft()` Default outer left cell margin/padding units.
    `byte` | `getFtsCellPaddingOuterRight()` Default outer right cell margin/padding units.
    `byte` | `getFtsCellPaddingOuterTop()` Default outer top cell margin/padding units.
    `byte` | `getFtsCellSpacingDefaultBottom()` Default bottom cell spacings units.
    `byte` | `getFtsCellSpacingDefaultLeft()` Default left cell spacings units.
    `byte` | `getFtsCellSpacingDefaultRight()` Default right cell spacings units.
    `byte` | `getFtsCellSpacingDefaultTop()` Default top cell spacings units.
    `byte` | `getFtsCellSpacingOuterBottom()` Default outer bottom cell spacings units.
    `byte` | `getFtsCellSpacingOuterLeft()` Default outer left cell spacings units.
    `byte` | `getFtsCellSpacingOuterRight()` Default outer right cell spacings units.
    `byte` | `getFtsCellSpacingOuterTop()` Default outer top cell spacings units.
    `byte` | `getFtsWidth()` Units for wWidth: 0 -- null; 1 -- auto, ignores wWidth, 2 -- percentage (in 50ths of a percent), 3 -- twips
    `byte` | `getFtsWidthAfter()` Units for wWidthAfter: 0 -- null; 1 -- auto, ignores wWidthAfter, 2 -- percentage (in 50ths of a percent), 3 -- twips
    `byte` | `getFtsWidthBefore()` Units for wWidthBefore: 0 -- null; 1 -- auto, ignores wWidthBefore, 2 -- percentage (in 50ths of a percent), 3 -- twips
    `byte` | `getFtsWidthIndent()` Units for wWidthIndent: 0 -- null; 1 -- auto, ignores wWidthIndent, 2 -- percentage (in 50ths of a percent), 3 -- twips
    `short` | `getGrpfTap_unused()` Not used
    `int` | `getGrpfTap()` Used internally by Word.
    `int` | `getInternalFlags()` Used internally by Word.
    `short` | `getIstd()` Table style for the Table.
    `short` | `getItcMac()` Count of cells defined for this row.
    `short` | `getJc()` Justification code.
    `byte` | `getPcHorz()` Horizontal position code.
    `short` | `getPctWwd()` Used internally by Word: percent of Window size for AutoFit in WebView.
    `byte` | `getPcVert()` Vertical position code.
    `BorderCode` | `getRgbrcInsideDefault_0()` Border definition for inside horizontal borders.
    `BorderCode` | `getRgbrcInsideDefault_1()` Border definition for inside vertical borders.
    `short[]` | `getRgdxaCenter()` rgdxaCenter[0] is the left boundary of cell 0 measured relative to margin rgdxaCenter[tap.itcMac - 1] is left boundary of last cell rgdxaCenter[tap.itcMac] is right boundary of last cell..
    `short[]` | `getRgdxaCenterPrint()` Used internally by Word.
    `ShadingDescriptor[]` | `getRgshd()` Get the rgshd field for the TAP record.
    `TableCellDescriptor[]` | `getRgtc()` Get the rgtc field for the TAP record.
    `ShadingDescriptor` | `getShdTable()` Table shading.
    `TableAutoformatLookSpecifier` | `getTlp()` Table look specifier.
    `short` | `getViewFlags_unused2()` Not used
    `int` | `getViewFlags()` Used internally by Word.
    `short` | `getWCellPaddingDefaultBottom()` Default bottom cell margin/padding.
    `short` | `getWCellPaddingDefaultLeft()` Default left cell margin/padding.
    `short` | `getWCellPaddingDefaultRight()` Default right cell margin/padding.
    `short` | `getWCellPaddingDefaultTop()` Default top cell margin/padding.
    `short` | `getWCellPaddingOuterBottom()` Default outer bottom cell margin/padding.
    `short` | `getWCellPaddingOuterLeft()` Default outer left cell margin/padding.
    `short` | `getWCellPaddingOuterRight()` Default outer right cell margin/padding.
    `short` | `getWCellPaddingOuterTop()` Default outer top cell margin/padding.
    `short` | `getWCellSpacingDefaultBottom()` Default bottom cell spacings.
    `short` | `getWCellSpacingDefaultLeft()` Default left cell spacings.
    `short` | `getWCellSpacingDefaultRight()` Default right cell spacings.
    `short` | `getWCellSpacingDefaultTop()` Default top cell spacings.
    `short` | `getWCellSpacingOuterBottom()` Default outer bottom cell spacing.
    `short` | `getWCellSpacingOuterLeft()` Default outer left cell spacing.
    `short` | `getWCellSpacingOuterRight()` Default outer right cell spacing.
    `short` | `getWCellSpacingOuterTop()` Default outer top cell spacing.
    `byte` | `getWidthAndFitsFlags_empty1()` Not used
    `short` | `getWidthAndFitsFlags_empty2()` Not used
    `int` | `getWidthAndFitsFlags()` Get the widthAndFitsFlags field for the TAP record.
    `short` | `getWWidth()` Preferred table width.
    `short` | `getWWidthAfter()` Width of invisible cell (used for layout purposes) after the last visible cell in the row..
    `short` | `getWWidthBefore()` Width of invisible cell (used for layout purposes) before the first visible cell in the row..
    `short` | `getWWidthIndent()` Left Indent.
    `boolean` | `isFAdjusted()` Used internally by Word
    `boolean` | `isFAutofit()` When set to 1, AutoFit this table
    `boolean` | `isFCellSpacing()` Used internally by Word: When set to 1 cell spacing is allowed
    `boolean` | `isFFirstRow()` Used internally by Word: first row
    `boolean` | `isFInvalAutofit()` When 1, TAP is still valid, but autofit properties aren't
    `boolean` | `isFKeepFollow()` When set to 1, keep this row with the following row
    `boolean` | `isFLastRow()` Used internally by Word: last row
    `boolean` | `isFNeverBeenAutofit()` When 1, table has never been autofit
    `boolean` | `isFNotPageView()` Used internally by Word: when set to 1 we are not in Page View
    `boolean` | `isFOrigWordTableRules()` Used internally by Word: table combining like Word 5.x for the Macintosh and WinWord 1.x
    `boolean` | `isFOutline()` Used internally by Word: row was cached for outline mode
    `boolean` | `isFVert()` When 1, positioned in vertical text flow
    `boolean` | `isFWebView()` Used internally by Word: Web View is on when set to 1
    `boolean` | `isFWrapToWwd()` Used internally by Word: Wrap to window is on when set to 1
    `boolean` | `isViewFlags_unused1()` Not used
    `void` | `setBrcBottom(BorderCode field_36_brcBottom)` Set the brcBottom field for the TAP record.
    `void` | `setBrcHorizontal(BorderCode field_41_brcHorizontal)` Set the brcHorizontal field for the TAP record.
    `void` | `setBrcLeft(BorderCode field_38_brcLeft)` Set the brcLeft field for the TAP record.
    `void` | `setBrcRight(BorderCode field_39_brcRight)` Set the brcRight field for the TAP record.
    `void` | `setBrcTop(BorderCode field_37_brcTop)` Set the brcTop field for the TAP record.
    `void` | `setBrcVertical(BorderCode field_40_brcVertical)` Set the brcVertical field for the TAP record.
    `void` | `setCHorzBands(short field_78_cHorzBands)` Size of each horizontal style band, in number of rows.
    `void` | `setCVertBands(short field_79_cVertBands)` Size of a vertical style band, in number of columns.
    `void` | `setDxaAbs(int field_14_dxaAbs)` Absolute horizontal position.
    `void` | `setDxaAdjust(int field_27_dxaAdjust)` Used internally by Word.
    `void` | `setDxaColWidthWwd(int field_30_dxaColWidthWwd)` Used internally by Word.
    `void` | `setDxaFromText(int field_16_dxaFromText)` Left distance from surrounding text when absolutely positioned.
    `void` | `setDxaFromTextRight(int field_18_dxaFromTextRight)` Right distance from surrounding text when absolutely positioned.
    `void` | `setDxaGapHalf(int field_3_dxaGapHalf)` Measures half of the white space that will be maintained between text in adjacent columns of a table row.
    `void` | `setDxaRTEWrapWidth(int field_29_dxaRTEWrapWidth)` Used internally by Word.
    `void` | `setDxaWebView(int field_28_dxaWebView)` Used internally by Word.
    `void` | `setDyaAbs(int field_15_dyaAbs)` Absolute vertical position.
    `void` | `setDyaFromText(int field_17_dyaFromText)` Top distance from surrounding text when absolutely positioned.
    `void` | `setDyaFromTextBottom(int field_19_dyaFromTextBottom)` Bottom distance from surrounding text when absolutely positioned.
    `void` | `setDyaRowHeight(int field_4_dyaRowHeight)` When greater than 0, guarantees that the height of the table will be at least dyaRowHeight high.
    `void` | `setFAdjusted(boolean value)` Sets the fAdjusted field value.
    `void` | `setFAutofit(boolean value)` Sets the fAutofit field value.
    `void` | `setFBiDi(byte field_20_fBiDi)` When 1, table is right-to-left.
    `void` | `setFCantSplit(boolean field_5_fCantSplit)` When 1, table row may not be split across page bounds.
    `void` | `setFCantSplit90(boolean field_6_fCantSplit90)` When 1, table row may not be split across page bounds.
    `void` | `setFCellSpacing(boolean value)` Sets the fCellSpacing field value.
    `void` | `setFFirstRow(boolean value)` Sets the fFirstRow field value.
    `void` | `setFHasOldProps(byte field_77_fHasOldProps)` Has old properties.
    `void` | `setFInvalAutofit(boolean value)` Sets the fInvalAutofit field value.
    `void` | `setFKeepFollow(boolean value)` Sets the fKeepFollow field value.
    `void` | `setFLastRow(boolean value)` Sets the fLastRow field value.
    `void` | `setFNeverBeenAutofit(boolean value)` Sets the fNeverBeenAutofit field value.
    `void` | `setFNoAllowOverlap(byte field_22_fNoAllowOverlap)` When set to 1, do not allow absolutely positioned table to overlap with other tables.
    `void` | `setFNotPageView(boolean value)` Sets the fNotPageView field value.
    `void` | `setFOrigWordTableRules(boolean value)` Sets the fOrigWordTableRules field value.
    `void` | `setFOutline(boolean value)` Sets the fOutline field value.
    `void` | `setFPropRMark(byte field_76_fPropRMark)` Set to 1 if property revision.
    `void` | `setFRTL(byte field_21_fRTL)` Word 2000 style right-to-left table.
    `void` | `setFSpare(byte field_23_fSpare)` Not used.
    `void` | `setFTableHeader(boolean field_7_fTableHeader)` When 1, table row is to be used as the header of the table.
    `void` | `setFtsCellPaddingDefaultBottom(byte field_48_ftsCellPaddingDefaultBottom)` Default bottom cell margin/padding units.
    `void` | `setFtsCellPaddingDefaultLeft(byte field_47_ftsCellPaddingDefaultLeft)` Default left cell margin/padding units.
    `void` | `setFtsCellPaddingDefaultRight(byte field_49_ftsCellPaddingDefaultRight)` Default right cell margin/padding units.
    `void` | `setFtsCellPaddingDefaultTop(byte field_46_ftsCellPaddingDefaultTop)` Default top cell margin/padding units.
    `void` | `setFtsCellPaddingOuterBottom(byte field_64_ftsCellPaddingOuterBottom)` Default outer bottom cell margin/padding units.
    `void` | `setFtsCellPaddingOuterLeft(byte field_63_ftsCellPaddingOuterLeft)` Default outer left cell margin/padding units.
    `void` | `setFtsCellPaddingOuterRight(byte field_65_ftsCellPaddingOuterRight)` Default outer right cell margin/padding units.
    `void` | `setFtsCellPaddingOuterTop(byte field_62_ftsCellPaddingOuterTop)` Default outer top cell margin/padding units.
    `void` | `setFtsCellSpacingDefaultBottom(byte field_56_ftsCellSpacingDefaultBottom)` Default bottom cell spacings units.
    `void` | `setFtsCellSpacingDefaultLeft(byte field_55_ftsCellSpacingDefaultLeft)` Default left cell spacings units.
    `void` | `setFtsCellSpacingDefaultRight(byte field_57_ftsCellSpacingDefaultRight)` Default right cell spacings units.
    `void` | `setFtsCellSpacingDefaultTop(byte field_54_ftsCellSpacingDefaultTop)` Default top cell spacings units.
    `void` | `setFtsCellSpacingOuterBottom(byte field_72_ftsCellSpacingOuterBottom)` Default outer bottom cell spacings units.
    `void` | `setFtsCellSpacingOuterLeft(byte field_71_ftsCellSpacingOuterLeft)` Default outer left cell spacings units.
    `void` | `setFtsCellSpacingOuterRight(byte field_73_ftsCellSpacingOuterRight)` Default outer right cell spacings units.
    `void` | `setFtsCellSpacingOuterTop(byte field_70_ftsCellSpacingOuterTop)` Default outer top cell spacings units.
    `void` | `setFtsWidth(byte value)` Sets the ftsWidth field value.
    `void` | `setFtsWidthAfter(byte value)` Sets the ftsWidthAfter field value.
    `void` | `setFtsWidthBefore(byte value)` Sets the ftsWidthBefore field value.
    `void` | `setFtsWidthIndent(byte value)` Sets the ftsWidthIndent field value.
    `void` | `setFVert(boolean value)` Sets the fVert field value.
    `void` | `setFWebView(boolean value)` Sets the fWebView field value.
    `void` | `setFWrapToWwd(boolean value)` Sets the fWrapToWwd field value.
    `void` | `setGrpfTap_unused(short value)` Sets the grpfTap_unused field value.
    `void` | `setGrpfTap(int field_24_grpfTap)` Used internally by Word.
    `void` | `setInternalFlags(int field_25_internalFlags)` Used internally by Word.
    `void` | `setIstd(short field_1_istd)` Table style for the Table.
    `void` | `setItcMac(short field_26_itcMac)` Count of cells defined for this row.
    `void` | `setJc(short field_2_jc)` Justification code.
    `void` | `setPcHorz(byte value)` Sets the pcHorz field value.
    `void` | `setPctWwd(short field_31_pctWwd)` Used internally by Word: percent of Window size for AutoFit in WebView.
    `void` | `setPcVert(byte value)` Sets the pcVert field value.
    `void` | `setRgbrcInsideDefault_0(BorderCode field_80_rgbrcInsideDefault_0)` Border definition for inside horizontal borders.
    `void` | `setRgbrcInsideDefault_1(BorderCode field_81_rgbrcInsideDefault_1)` Border definition for inside vertical borders.
    `void` | `setRgdxaCenter(short[] field_33_rgdxaCenter)` rgdxaCenter[0] is the left boundary of cell 0 measured relative to margin rgdxaCenter[tap.itcMac - 1] is left boundary of last cell rgdxaCenter[tap.itcMac] is right boundary of last cell..
    `void` | `setRgdxaCenterPrint(short[] field_34_rgdxaCenterPrint)` Used internally by Word.
    `void` | `setRgshd(ShadingDescriptor[] field_75_rgshd)` Set the rgshd field for the TAP record.
    `void` | `setRgtc(TableCellDescriptor[] field_74_rgtc)` Set the rgtc field for the TAP record.
    `void` | `setShdTable(ShadingDescriptor field_35_shdTable)` Table shading.
    `void` | `setTlp(TableAutoformatLookSpecifier field_8_tlp)` Table look specifier.
    `void` | `setViewFlags_unused1(boolean value)` Sets the viewFlags_unused1 field value.
    `void` | `setViewFlags_unused2(short value)` Sets the viewFlags_unused2 field value.
    `void` | `setViewFlags(int field_32_viewFlags)` Used internally by Word.
    `void` | `setWCellPaddingDefaultBottom(short field_44_wCellPaddingDefaultBottom)` Default bottom cell margin/padding.
    `void` | `setWCellPaddingDefaultLeft(short field_43_wCellPaddingDefaultLeft)` Default left cell margin/padding.
    `void` | `setWCellPaddingDefaultRight(short field_45_wCellPaddingDefaultRight)` Default right cell margin/padding.
    `void` | `setWCellPaddingDefaultTop(short field_42_wCellPaddingDefaultTop)` Default top cell margin/padding.
    `void` | `setWCellPaddingOuterBottom(short field_60_wCellPaddingOuterBottom)` Default outer bottom cell margin/padding.
    `void` | `setWCellPaddingOuterLeft(short field_59_wCellPaddingOuterLeft)` Default outer left cell margin/padding.
    `void` | `setWCellPaddingOuterRight(short field_61_wCellPaddingOuterRight)` Default outer right cell margin/padding.
    `void` | `setWCellPaddingOuterTop(short field_58_wCellPaddingOuterTop)` Default outer top cell margin/padding.
    `void` | `setWCellSpacingDefaultBottom(short field_52_wCellSpacingDefaultBottom)` Default bottom cell spacings.
    `void` | `setWCellSpacingDefaultLeft(short field_51_wCellSpacingDefaultLeft)` Default left cell spacings.
    `void` | `setWCellSpacingDefaultRight(short field_53_wCellSpacingDefaultRight)` Default right cell spacings.
    `void` | `setWCellSpacingDefaultTop(short field_50_wCellSpacingDefaultTop)` Default top cell spacings.
    `void` | `setWCellSpacingOuterBottom(short field_68_wCellSpacingOuterBottom)` Default outer bottom cell spacing.
    `void` | `setWCellSpacingOuterLeft(short field_67_wCellSpacingOuterLeft)` Default outer left cell spacing.
    `void` | `setWCellSpacingOuterRight(short field_69_wCellSpacingOuterRight)` Default outer right cell spacing.
    `void` | `setWCellSpacingOuterTop(short field_66_wCellSpacingOuterTop)` Default outer top cell spacing.
    `void` | `setWidthAndFitsFlags_empty1(byte value)` Sets the widthAndFitsFlags_empty1 field value.
    `void` | `setWidthAndFitsFlags_empty2(short value)` Sets the widthAndFitsFlags_empty2 field value.
    `void` | `setWidthAndFitsFlags(int field_13_widthAndFitsFlags)` Set the widthAndFitsFlags field for the TAP record.
    `void` | `setWWidth(short field_9_wWidth)` Preferred table width.
    `void` | `setWWidthAfter(short field_12_wWidthAfter)` Width of invisible cell (used for layout purposes) after the last visible cell in the row..
    `void` | `setWWidthBefore(short field_11_wWidthBefore)` Width of invisible cell (used for layout purposes) before the first visible cell in the row..
    `void` | `setWWidthIndent(short field_10_wWidthIndent)` Left Indent.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### field_1_istd

          protected short field_1_istd

    - #### field_2_jc

          protected short field_2_jc

    - #### field_3_dxaGapHalf

          protected int field_3_dxaGapHalf

    - #### field_4_dyaRowHeight

          protected int field_4_dyaRowHeight

    - #### field_5_fCantSplit

          protected boolean field_5_fCantSplit

    - #### field_6_fCantSplit90

          protected boolean field_6_fCantSplit90

    - #### field_7_fTableHeader

          protected boolean field_7_fTableHeader

    - #### field_8_tlp

          protected TableAutoformatLookSpecifier field_8_tlp

    - #### field_9_wWidth

          protected short field_9_wWidth

    - #### field_10_wWidthIndent

          protected short field_10_wWidthIndent

    - #### field_11_wWidthBefore

          protected short field_11_wWidthBefore

    - #### field_12_wWidthAfter

          protected short field_12_wWidthAfter

    - #### field_13_widthAndFitsFlags

          protected int field_13_widthAndFitsFlags

    - #### field_14_dxaAbs

          protected int field_14_dxaAbs

    - #### field_15_dyaAbs

          protected int field_15_dyaAbs

    - #### field_16_dxaFromText

          protected int field_16_dxaFromText

    - #### field_17_dyaFromText

          protected int field_17_dyaFromText

    - #### field_18_dxaFromTextRight

          protected int field_18_dxaFromTextRight

    - #### field_19_dyaFromTextBottom

          protected int field_19_dyaFromTextBottom

    - #### field_20_fBiDi

          protected byte field_20_fBiDi

    - #### field_21_fRTL

          protected byte field_21_fRTL

    - #### field_22_fNoAllowOverlap

          protected byte field_22_fNoAllowOverlap

    - #### field_23_fSpare

          protected byte field_23_fSpare

    - #### field_24_grpfTap

          protected int field_24_grpfTap

    - #### field_25_internalFlags

          protected int field_25_internalFlags

    - #### field_26_itcMac

          protected short field_26_itcMac

    - #### field_27_dxaAdjust

          protected int field_27_dxaAdjust

    - #### field_28_dxaWebView

          protected int field_28_dxaWebView

    - #### field_29_dxaRTEWrapWidth

          protected int field_29_dxaRTEWrapWidth

    - #### field_30_dxaColWidthWwd

          protected int field_30_dxaColWidthWwd

    - #### field_31_pctWwd

          protected short field_31_pctWwd

    - #### field_32_viewFlags

          protected int field_32_viewFlags

    - #### field_33_rgdxaCenter

          protected short[] field_33_rgdxaCenter

    - #### field_34_rgdxaCenterPrint

          protected short[] field_34_rgdxaCenterPrint

    - #### field_35_shdTable

          protected ShadingDescriptor field_35_shdTable

    - #### field_36_brcBottom

          protected BorderCode field_36_brcBottom

    - #### field_37_brcTop

          protected BorderCode field_37_brcTop

    - #### field_38_brcLeft

          protected BorderCode field_38_brcLeft

    - #### field_39_brcRight

          protected BorderCode field_39_brcRight

    - #### field_40_brcVertical

          protected BorderCode field_40_brcVertical

    - #### field_41_brcHorizontal

          protected BorderCode field_41_brcHorizontal

    - #### field_42_wCellPaddingDefaultTop

          protected short field_42_wCellPaddingDefaultTop

    - #### field_43_wCellPaddingDefaultLeft

          protected short field_43_wCellPaddingDefaultLeft

    - #### field_44_wCellPaddingDefaultBottom

          protected short field_44_wCellPaddingDefaultBottom

    - #### field_45_wCellPaddingDefaultRight

          protected short field_45_wCellPaddingDefaultRight

    - #### field_46_ftsCellPaddingDefaultTop

          protected byte field_46_ftsCellPaddingDefaultTop

    - #### field_47_ftsCellPaddingDefaultLeft

          protected byte field_47_ftsCellPaddingDefaultLeft

    - #### field_48_ftsCellPaddingDefaultBottom

          protected byte field_48_ftsCellPaddingDefaultBottom

    - #### field_49_ftsCellPaddingDefaultRight

          protected byte field_49_ftsCellPaddingDefaultRight

    - #### field_50_wCellSpacingDefaultTop

          protected short field_50_wCellSpacingDefaultTop

    - #### field_51_wCellSpacingDefaultLeft

          protected short field_51_wCellSpacingDefaultLeft

    - #### field_52_wCellSpacingDefaultBottom

          protected short field_52_wCellSpacingDefaultBottom

    - #### field_53_wCellSpacingDefaultRight

          protected short field_53_wCellSpacingDefaultRight

    - #### field_54_ftsCellSpacingDefaultTop

          protected byte field_54_ftsCellSpacingDefaultTop

    - #### field_55_ftsCellSpacingDefaultLeft

          protected byte field_55_ftsCellSpacingDefaultLeft

    - #### field_56_ftsCellSpacingDefaultBottom

          protected byte field_56_ftsCellSpacingDefaultBottom

    - #### field_57_ftsCellSpacingDefaultRight

          protected byte field_57_ftsCellSpacingDefaultRight

    - #### field_58_wCellPaddingOuterTop

          protected short field_58_wCellPaddingOuterTop

    - #### field_59_wCellPaddingOuterLeft

          protected short field_59_wCellPaddingOuterLeft

    - #### field_60_wCellPaddingOuterBottom

          protected short field_60_wCellPaddingOuterBottom

    - #### field_61_wCellPaddingOuterRight

          protected short field_61_wCellPaddingOuterRight

    - #### field_62_ftsCellPaddingOuterTop

          protected byte field_62_ftsCellPaddingOuterTop

    - #### field_63_ftsCellPaddingOuterLeft

          protected byte field_63_ftsCellPaddingOuterLeft

    - #### field_64_ftsCellPaddingOuterBottom

          protected byte field_64_ftsCellPaddingOuterBottom

    - #### field_65_ftsCellPaddingOuterRight

          protected byte field_65_ftsCellPaddingOuterRight

    - #### field_66_wCellSpacingOuterTop

          protected short field_66_wCellSpacingOuterTop

    - #### field_67_wCellSpacingOuterLeft

          protected short field_67_wCellSpacingOuterLeft

    - #### field_68_wCellSpacingOuterBottom

          protected short field_68_wCellSpacingOuterBottom

    - #### field_69_wCellSpacingOuterRight

          protected short field_69_wCellSpacingOuterRight

    - #### field_70_ftsCellSpacingOuterTop

          protected byte field_70_ftsCellSpacingOuterTop

    - #### field_71_ftsCellSpacingOuterLeft

          protected byte field_71_ftsCellSpacingOuterLeft

    - #### field_72_ftsCellSpacingOuterBottom

          protected byte field_72_ftsCellSpacingOuterBottom

    - #### field_73_ftsCellSpacingOuterRight

          protected byte field_73_ftsCellSpacingOuterRight

    - #### field_74_rgtc

          protected TableCellDescriptor[] field_74_rgtc

    - #### field_75_rgshd

          protected ShadingDescriptor[] field_75_rgshd

    - #### field_76_fPropRMark

          protected byte field_76_fPropRMark

    - #### field_77_fHasOldProps

          protected byte field_77_fHasOldProps

    - #### field_78_cHorzBands

          protected short field_78_cHorzBands

    - #### field_79_cVertBands

          protected short field_79_cVertBands

    - #### field_80_rgbrcInsideDefault_0

          protected BorderCode field_80_rgbrcInsideDefault_0

    - #### field_81_rgbrcInsideDefault_1

          protected BorderCode field_81_rgbrcInsideDefault_1

  - ### Constructor Detail

    - #### TAPAbstractType

          protected TAPAbstractType()

    - #### TAPAbstractType

          protected TAPAbstractType(TAPAbstractType other)

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getIstd

          @Internal
          public short getIstd()

      Table style for the Table.

    - #### setIstd

          @Internal
          public void setIstd(short field_1_istd)

      Table style for the Table.

    - #### getJc

          @Internal
          public short getJc()

      Justification code. specifies how table row should be justified within its column. 0 -- left justify, 1 -- center, 2 -- right justify.

    - #### setJc

          @Internal
          public void setJc(short field_2_jc)

      Justification code. specifies how table row should be justified within its column. 0 -- left justify, 1 -- center, 2 -- right justify.

    - #### getDxaGapHalf

          @Internal
          public int getDxaGapHalf()

      Measures half of the white space that will be maintained between text in adjacent columns of a table row. A dxaGapHalf width of white space will be maintained on both sides of a column boundary..

    - #### setDxaGapHalf

          @Internal
          public void setDxaGapHalf(int field_3_dxaGapHalf)

      Measures half of the white space that will be maintained between text in adjacent columns of a table row. A dxaGapHalf width of white space will be maintained on both sides of a column boundary..

    - #### getDyaRowHeight

          @Internal
          public int getDyaRowHeight()

      When greater than 0, guarantees that the height of the table will be at least dyaRowHeight high. When less than 0, guarantees that the height of the table will be exactly absolute value of dyaRowHeight high. When 0, table will be given a height large enough to represent all of the text in all of the cells of the table. Cells with vertical text flow make no contribution to the computation of the height of rows with auto or at least height. Neither do vertically merged cells, except in the last row of the vertical merge. If an auto height row consists entirely of cells which have vertical text direction or are vertically merged, and the row does not contain the last cell in any vertical cell merge, then the row is given height equal to that of the end of cell mark in the first cell..

    - #### setDyaRowHeight

          @Internal
          public void setDyaRowHeight(int field_4_dyaRowHeight)

      When greater than 0, guarantees that the height of the table will be at least dyaRowHeight high. When less than 0, guarantees that the height of the table will be exactly absolute value of dyaRowHeight high. When 0, table will be given a height large enough to represent all of the text in all of the cells of the table. Cells with vertical text flow make no contribution to the computation of the height of rows with auto or at least height. Neither do vertically merged cells, except in the last row of the vertical merge. If an auto height row consists entirely of cells which have vertical text direction or are vertically merged, and the row does not contain the last cell in any vertical cell merge, then the row is given height equal to that of the end of cell mark in the first cell..

    - #### getFCantSplit

          @Internal
          public boolean getFCantSplit()

      When 1, table row may not be split across page bounds.

    - #### setFCantSplit

          @Internal
          public void setFCantSplit(boolean field_5_fCantSplit)

      When 1, table row may not be split across page bounds.

    - #### getFCantSplit90

          @Internal
          public boolean getFCantSplit90()

      When 1, table row may not be split across page bounds. Used for Word 2000 and Word 97..

    - #### setFCantSplit90

          @Internal
          public void setFCantSplit90(boolean field_6_fCantSplit90)

      When 1, table row may not be split across page bounds. Used for Word 2000 and Word 97..

    - #### getFTableHeader

          @Internal
          public boolean getFTableHeader()

      When 1, table row is to be used as the header of the table.

    - #### setFTableHeader

          @Internal
          public void setFTableHeader(boolean field_7_fTableHeader)

      When 1, table row is to be used as the header of the table.

    - #### getTlp

          @Internal
          public TableAutoformatLookSpecifier getTlp()

      Table look specifier.

    - #### setTlp

          @Internal
          public void setTlp(TableAutoformatLookSpecifier field_8_tlp)

      Table look specifier.

    - #### getWWidth

          @Internal
          public short getWWidth()

      Preferred table width.

    - #### setWWidth

          @Internal
          public void setWWidth(short field_9_wWidth)

      Preferred table width.

    - #### getWWidthIndent

          @Internal
          public short getWWidthIndent()

      Left Indent.

    - #### setWWidthIndent

          @Internal
          public void setWWidthIndent(short field_10_wWidthIndent)

      Left Indent.

    - #### getWWidthBefore

          @Internal
          public short getWWidthBefore()

      Width of invisible cell (used for layout purposes) before the first visible cell in the row..

    - #### setWWidthBefore

          @Internal
          public void setWWidthBefore(short field_11_wWidthBefore)

      Width of invisible cell (used for layout purposes) before the first visible cell in the row..

    - #### getWWidthAfter

          @Internal
          public short getWWidthAfter()

      Width of invisible cell (used for layout purposes) after the last visible cell in the row..

    - #### setWWidthAfter

          @Internal
          public void setWWidthAfter(short field_12_wWidthAfter)

      Width of invisible cell (used for layout purposes) after the last visible cell in the row..

    - #### getWidthAndFitsFlags

          @Internal
          public int getWidthAndFitsFlags()

      Get the widthAndFitsFlags field for the TAP record.

    - #### setWidthAndFitsFlags

          @Internal
          public void setWidthAndFitsFlags(int field_13_widthAndFitsFlags)

      Set the widthAndFitsFlags field for the TAP record.

    - #### getDxaAbs

          @Internal
          public int getDxaAbs()

      Absolute horizontal position.

    - #### setDxaAbs

          @Internal
          public void setDxaAbs(int field_14_dxaAbs)

      Absolute horizontal position.

    - #### getDyaAbs

          @Internal
          public int getDyaAbs()

      Absolute vertical position.

    - #### setDyaAbs

          @Internal
          public void setDyaAbs(int field_15_dyaAbs)

      Absolute vertical position.

    - #### getDxaFromText

          @Internal
          public int getDxaFromText()

      Left distance from surrounding text when absolutely positioned.

    - #### setDxaFromText

          @Internal
          public void setDxaFromText(int field_16_dxaFromText)

      Left distance from surrounding text when absolutely positioned.

    - #### getDyaFromText

          @Internal
          public int getDyaFromText()

      Top distance from surrounding text when absolutely positioned.

    - #### setDyaFromText

          @Internal
          public void setDyaFromText(int field_17_dyaFromText)

      Top distance from surrounding text when absolutely positioned.

    - #### getDxaFromTextRight

          @Internal
          public int getDxaFromTextRight()

      Right distance from surrounding text when absolutely positioned.

    - #### setDxaFromTextRight

          @Internal
          public void setDxaFromTextRight(int field_18_dxaFromTextRight)

      Right distance from surrounding text when absolutely positioned.

    - #### getDyaFromTextBottom

          @Internal
          public int getDyaFromTextBottom()

      Bottom distance from surrounding text when absolutely positioned.

    - #### setDyaFromTextBottom

          @Internal
          public void setDyaFromTextBottom(int field_19_dyaFromTextBottom)

      Bottom distance from surrounding text when absolutely positioned.

    - #### getFBiDi

          @Internal
          public byte getFBiDi()

      When 1, table is right-to-left. Logical right-to-left table: The CP stream of a right-to-left table is meant to be displayed from right to left. So for example the first table cell is displayed on the right side of the table instead of the left..

    - #### setFBiDi

          @Internal
          public void setFBiDi(byte field_20_fBiDi)

      When 1, table is right-to-left. Logical right-to-left table: The CP stream of a right-to-left table is meant to be displayed from right to left. So for example the first table cell is displayed on the right side of the table instead of the left..

    - #### getFRTL

          @Internal
          public byte getFRTL()

      Word 2000 style right-to-left table. Visual right-to-left table: The CP stream of a right-to-left table is displayed from left to right just as for a normal table. So, the text which is meant to be in the first (rightmost) table cell must be placed in the last table cell in the CP stream..

    - #### setFRTL

          @Internal
          public void setFRTL(byte field_21_fRTL)

      Word 2000 style right-to-left table. Visual right-to-left table: The CP stream of a right-to-left table is displayed from left to right just as for a normal table. So, the text which is meant to be in the first (rightmost) table cell must be placed in the last table cell in the CP stream..

    - #### getFNoAllowOverlap

          @Internal
          public byte getFNoAllowOverlap()

      When set to 1, do not allow absolutely positioned table to overlap with other tables.

    - #### setFNoAllowOverlap

          @Internal
          public void setFNoAllowOverlap(byte field_22_fNoAllowOverlap)

      When set to 1, do not allow absolutely positioned table to overlap with other tables.

    - #### getFSpare

          @Internal
          public byte getFSpare()

      Not used.

    - #### setFSpare

          @Internal
          public void setFSpare(byte field_23_fSpare)

      Not used.

    - #### getGrpfTap

          @Internal
          public int getGrpfTap()

      Used internally by Word.

    - #### setGrpfTap

          @Internal
          public void setGrpfTap(int field_24_grpfTap)

      Used internally by Word.

    - #### getInternalFlags

          @Internal
          public int getInternalFlags()

      Used internally by Word.

    - #### setInternalFlags

          @Internal
          public void setInternalFlags(int field_25_internalFlags)

      Used internally by Word.

    - #### getItcMac

          @Internal
          public short getItcMac()

      Count of cells defined for this row. itcMac must be >= 0 and less than or equal to 64..

    - #### setItcMac

          @Internal
          public void setItcMac(short field_26_itcMac)

      Count of cells defined for this row. itcMac must be >= 0 and less than or equal to 64..

    - #### getDxaAdjust

          @Internal
          public int getDxaAdjust()

      Used internally by Word.

    - #### setDxaAdjust

          @Internal
          public void setDxaAdjust(int field_27_dxaAdjust)

      Used internally by Word.

    - #### getDxaWebView

          @Internal
          public int getDxaWebView()

      Used internally by Word.

    - #### setDxaWebView

          @Internal
          public void setDxaWebView(int field_28_dxaWebView)

      Used internally by Word.

    - #### getDxaRTEWrapWidth

          @Internal
          public int getDxaRTEWrapWidth()

      Used internally by Word.

    - #### setDxaRTEWrapWidth

          @Internal
          public void setDxaRTEWrapWidth(int field_29_dxaRTEWrapWidth)

      Used internally by Word.

    - #### getDxaColWidthWwd

          @Internal
          public int getDxaColWidthWwd()

      Used internally by Word.

    - #### setDxaColWidthWwd

          @Internal
          public void setDxaColWidthWwd(int field_30_dxaColWidthWwd)

      Used internally by Word.

    - #### getPctWwd

          @Internal
          public short getPctWwd()

      Used internally by Word: percent of Window size for AutoFit in WebView.

    - #### setPctWwd

          @Internal
          public void setPctWwd(short field_31_pctWwd)

      Used internally by Word: percent of Window size for AutoFit in WebView.

    - #### getViewFlags

          @Internal
          public int getViewFlags()

      Used internally by Word.

    - #### setViewFlags

          @Internal
          public void setViewFlags(int field_32_viewFlags)

      Used internally by Word.

    - #### getRgdxaCenter

          @Internal
          public short[] getRgdxaCenter()

      rgdxaCenter[0] is the left boundary of cell 0 measured relative to margin rgdxaCenter[tap.itcMac - 1] is left boundary of last cell rgdxaCenter[tap.itcMac] is right boundary of last cell..

    - #### setRgdxaCenter

          @Internal
          public void setRgdxaCenter(short[] field_33_rgdxaCenter)

      rgdxaCenter[0] is the left boundary of cell 0 measured relative to margin rgdxaCenter[tap.itcMac - 1] is left boundary of last cell rgdxaCenter[tap.itcMac] is right boundary of last cell..

    - #### getRgdxaCenterPrint

          @Internal
          public short[] getRgdxaCenterPrint()

      Used internally by Word.

    - #### setRgdxaCenterPrint

          @Internal
          public void setRgdxaCenterPrint(short[] field_34_rgdxaCenterPrint)

      Used internally by Word.

    - #### getShdTable

          @Internal
          public ShadingDescriptor getShdTable()

      Table shading.

    - #### setShdTable

          @Internal
          public void setShdTable(ShadingDescriptor field_35_shdTable)

      Table shading.

    - #### getBrcBottom

          @Internal
          public BorderCode getBrcBottom()

      Get the brcBottom field for the TAP record.

    - #### setBrcBottom

          @Internal
          public void setBrcBottom(BorderCode field_36_brcBottom)

      Set the brcBottom field for the TAP record.

    - #### getBrcTop

          @Internal
          public BorderCode getBrcTop()

      Get the brcTop field for the TAP record.

    - #### setBrcTop

          @Internal
          public void setBrcTop(BorderCode field_37_brcTop)

      Set the brcTop field for the TAP record.

    - #### getBrcLeft

          @Internal
          public BorderCode getBrcLeft()

      Get the brcLeft field for the TAP record.

    - #### setBrcLeft

          @Internal
          public void setBrcLeft(BorderCode field_38_brcLeft)

      Set the brcLeft field for the TAP record.

    - #### getBrcRight

          @Internal
          public BorderCode getBrcRight()

      Get the brcRight field for the TAP record.

    - #### setBrcRight

          @Internal
          public void setBrcRight(BorderCode field_39_brcRight)

      Set the brcRight field for the TAP record.

    - #### getBrcVertical

          @Internal
          public BorderCode getBrcVertical()

      Get the brcVertical field for the TAP record.

    - #### setBrcVertical

          @Internal
          public void setBrcVertical(BorderCode field_40_brcVertical)

      Set the brcVertical field for the TAP record.

    - #### getBrcHorizontal

          @Internal
          public BorderCode getBrcHorizontal()

      Get the brcHorizontal field for the TAP record.

    - #### setBrcHorizontal

          @Internal
          public void setBrcHorizontal(BorderCode field_41_brcHorizontal)

      Set the brcHorizontal field for the TAP record.

    - #### getWCellPaddingDefaultTop

          @Internal
          public short getWCellPaddingDefaultTop()

      Default top cell margin/padding.

    - #### setWCellPaddingDefaultTop

          @Internal
          public void setWCellPaddingDefaultTop(short field_42_wCellPaddingDefaultTop)

      Default top cell margin/padding.

    - #### getWCellPaddingDefaultLeft

          @Internal
          public short getWCellPaddingDefaultLeft()

      Default left cell margin/padding.

    - #### setWCellPaddingDefaultLeft

          @Internal
          public void setWCellPaddingDefaultLeft(short field_43_wCellPaddingDefaultLeft)

      Default left cell margin/padding.

    - #### getWCellPaddingDefaultBottom

          @Internal
          public short getWCellPaddingDefaultBottom()

      Default bottom cell margin/padding.

    - #### setWCellPaddingDefaultBottom

          @Internal
          public void setWCellPaddingDefaultBottom(short field_44_wCellPaddingDefaultBottom)

      Default bottom cell margin/padding.

    - #### getWCellPaddingDefaultRight

          @Internal
          public short getWCellPaddingDefaultRight()

      Default right cell margin/padding.

    - #### setWCellPaddingDefaultRight

          @Internal
          public void setWCellPaddingDefaultRight(short field_45_wCellPaddingDefaultRight)

      Default right cell margin/padding.

    - #### getFtsCellPaddingDefaultTop

          @Internal
          public byte getFtsCellPaddingDefaultTop()

      Default top cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellPaddingDefaultTop

          @Internal
          public void setFtsCellPaddingDefaultTop(byte field_46_ftsCellPaddingDefaultTop)

      Default top cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellPaddingDefaultLeft

          @Internal
          public byte getFtsCellPaddingDefaultLeft()

      Default left cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellPaddingDefaultLeft

          @Internal
          public void setFtsCellPaddingDefaultLeft(byte field_47_ftsCellPaddingDefaultLeft)

      Default left cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellPaddingDefaultBottom

          @Internal
          public byte getFtsCellPaddingDefaultBottom()

      Default bottom cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellPaddingDefaultBottom

          @Internal
          public void setFtsCellPaddingDefaultBottom(byte field_48_ftsCellPaddingDefaultBottom)

      Default bottom cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellPaddingDefaultRight

          @Internal
          public byte getFtsCellPaddingDefaultRight()

      Default right cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellPaddingDefaultRight

          @Internal
          public void setFtsCellPaddingDefaultRight(byte field_49_ftsCellPaddingDefaultRight)

      Default right cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getWCellSpacingDefaultTop

          @Internal
          public short getWCellSpacingDefaultTop()

      Default top cell spacings.

    - #### setWCellSpacingDefaultTop

          @Internal
          public void setWCellSpacingDefaultTop(short field_50_wCellSpacingDefaultTop)

      Default top cell spacings.

    - #### getWCellSpacingDefaultLeft

          @Internal
          public short getWCellSpacingDefaultLeft()

      Default left cell spacings.

    - #### setWCellSpacingDefaultLeft

          @Internal
          public void setWCellSpacingDefaultLeft(short field_51_wCellSpacingDefaultLeft)

      Default left cell spacings.

    - #### getWCellSpacingDefaultBottom

          @Internal
          public short getWCellSpacingDefaultBottom()

      Default bottom cell spacings.

    - #### setWCellSpacingDefaultBottom

          @Internal
          public void setWCellSpacingDefaultBottom(short field_52_wCellSpacingDefaultBottom)

      Default bottom cell spacings.

    - #### getWCellSpacingDefaultRight

          @Internal
          public short getWCellSpacingDefaultRight()

      Default right cell spacings.

    - #### setWCellSpacingDefaultRight

          @Internal
          public void setWCellSpacingDefaultRight(short field_53_wCellSpacingDefaultRight)

      Default right cell spacings.

    - #### getFtsCellSpacingDefaultTop

          @Internal
          public byte getFtsCellSpacingDefaultTop()

      Default top cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellSpacingDefaultTop

          @Internal
          public void setFtsCellSpacingDefaultTop(byte field_54_ftsCellSpacingDefaultTop)

      Default top cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellSpacingDefaultLeft

          @Internal
          public byte getFtsCellSpacingDefaultLeft()

      Default left cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellSpacingDefaultLeft

          @Internal
          public void setFtsCellSpacingDefaultLeft(byte field_55_ftsCellSpacingDefaultLeft)

      Default left cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellSpacingDefaultBottom

          @Internal
          public byte getFtsCellSpacingDefaultBottom()

      Default bottom cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellSpacingDefaultBottom

          @Internal
          public void setFtsCellSpacingDefaultBottom(byte field_56_ftsCellSpacingDefaultBottom)

      Default bottom cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellSpacingDefaultRight

          @Internal
          public byte getFtsCellSpacingDefaultRight()

      Default right cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellSpacingDefaultRight

          @Internal
          public void setFtsCellSpacingDefaultRight(byte field_57_ftsCellSpacingDefaultRight)

      Default right cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getWCellPaddingOuterTop

          @Internal
          public short getWCellPaddingOuterTop()

      Default outer top cell margin/padding.

    - #### setWCellPaddingOuterTop

          @Internal
          public void setWCellPaddingOuterTop(short field_58_wCellPaddingOuterTop)

      Default outer top cell margin/padding.

    - #### getWCellPaddingOuterLeft

          @Internal
          public short getWCellPaddingOuterLeft()

      Default outer left cell margin/padding.

    - #### setWCellPaddingOuterLeft

          @Internal
          public void setWCellPaddingOuterLeft(short field_59_wCellPaddingOuterLeft)

      Default outer left cell margin/padding.

    - #### getWCellPaddingOuterBottom

          @Internal
          public short getWCellPaddingOuterBottom()

      Default outer bottom cell margin/padding.

    - #### setWCellPaddingOuterBottom

          @Internal
          public void setWCellPaddingOuterBottom(short field_60_wCellPaddingOuterBottom)

      Default outer bottom cell margin/padding.

    - #### getWCellPaddingOuterRight

          @Internal
          public short getWCellPaddingOuterRight()

      Default outer right cell margin/padding.

    - #### setWCellPaddingOuterRight

          @Internal
          public void setWCellPaddingOuterRight(short field_61_wCellPaddingOuterRight)

      Default outer right cell margin/padding.

    - #### getFtsCellPaddingOuterTop

          @Internal
          public byte getFtsCellPaddingOuterTop()

      Default outer top cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellPaddingOuterTop

          @Internal
          public void setFtsCellPaddingOuterTop(byte field_62_ftsCellPaddingOuterTop)

      Default outer top cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellPaddingOuterLeft

          @Internal
          public byte getFtsCellPaddingOuterLeft()

      Default outer left cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellPaddingOuterLeft

          @Internal
          public void setFtsCellPaddingOuterLeft(byte field_63_ftsCellPaddingOuterLeft)

      Default outer left cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellPaddingOuterBottom

          @Internal
          public byte getFtsCellPaddingOuterBottom()

      Default outer bottom cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellPaddingOuterBottom

          @Internal
          public void setFtsCellPaddingOuterBottom(byte field_64_ftsCellPaddingOuterBottom)

      Default outer bottom cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellPaddingOuterRight

          @Internal
          public byte getFtsCellPaddingOuterRight()

      Default outer right cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellPaddingOuterRight

          @Internal
          public void setFtsCellPaddingOuterRight(byte field_65_ftsCellPaddingOuterRight)

      Default outer right cell margin/padding units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getWCellSpacingOuterTop

          @Internal
          public short getWCellSpacingOuterTop()

      Default outer top cell spacing.

    - #### setWCellSpacingOuterTop

          @Internal
          public void setWCellSpacingOuterTop(short field_66_wCellSpacingOuterTop)

      Default outer top cell spacing.

    - #### getWCellSpacingOuterLeft

          @Internal
          public short getWCellSpacingOuterLeft()

      Default outer left cell spacing.

    - #### setWCellSpacingOuterLeft

          @Internal
          public void setWCellSpacingOuterLeft(short field_67_wCellSpacingOuterLeft)

      Default outer left cell spacing.

    - #### getWCellSpacingOuterBottom

          @Internal
          public short getWCellSpacingOuterBottom()

      Default outer bottom cell spacing.

    - #### setWCellSpacingOuterBottom

          @Internal
          public void setWCellSpacingOuterBottom(short field_68_wCellSpacingOuterBottom)

      Default outer bottom cell spacing.

    - #### getWCellSpacingOuterRight

          @Internal
          public short getWCellSpacingOuterRight()

      Default outer right cell spacing.

    - #### setWCellSpacingOuterRight

          @Internal
          public void setWCellSpacingOuterRight(short field_69_wCellSpacingOuterRight)

      Default outer right cell spacing.

    - #### getFtsCellSpacingOuterTop

          @Internal
          public byte getFtsCellSpacingOuterTop()

      Default outer top cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellSpacingOuterTop

          @Internal
          public void setFtsCellSpacingOuterTop(byte field_70_ftsCellSpacingOuterTop)

      Default outer top cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellSpacingOuterLeft

          @Internal
          public byte getFtsCellSpacingOuterLeft()

      Default outer left cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellSpacingOuterLeft

          @Internal
          public void setFtsCellSpacingOuterLeft(byte field_71_ftsCellSpacingOuterLeft)

      Default outer left cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellSpacingOuterBottom

          @Internal
          public byte getFtsCellSpacingOuterBottom()

      Default outer bottom cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellSpacingOuterBottom

          @Internal
          public void setFtsCellSpacingOuterBottom(byte field_72_ftsCellSpacingOuterBottom)

      Default outer bottom cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getFtsCellSpacingOuterRight

          @Internal
          public byte getFtsCellSpacingOuterRight()

      Default outer right cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### setFtsCellSpacingOuterRight

          @Internal
          public void setFtsCellSpacingOuterRight(byte field_73_ftsCellSpacingOuterRight)

      Default outer right cell spacings units. 0 -- null; 1-2 -- not relevant; 3 -- twips..

    - #### getRgtc

          @Internal
          public TableCellDescriptor[] getRgtc()

      Get the rgtc field for the TAP record.

    - #### setRgtc

          @Internal
          public void setRgtc(TableCellDescriptor[] field_74_rgtc)

      Set the rgtc field for the TAP record.

    - #### getRgshd

          @Internal
          public ShadingDescriptor[] getRgshd()

      Get the rgshd field for the TAP record.

    - #### setRgshd

          @Internal
          public void setRgshd(ShadingDescriptor[] field_75_rgshd)

      Set the rgshd field for the TAP record.

    - #### getFPropRMark

          @Internal
          public byte getFPropRMark()

      Set to 1 if property revision.

    - #### setFPropRMark

          @Internal
          public void setFPropRMark(byte field_76_fPropRMark)

      Set to 1 if property revision.

    - #### getFHasOldProps

          @Internal
          public byte getFHasOldProps()

      Has old properties.

    - #### setFHasOldProps

          @Internal
          public void setFHasOldProps(byte field_77_fHasOldProps)

      Has old properties.

    - #### getCHorzBands

          @Internal
          public short getCHorzBands()

      Size of each horizontal style band, in number of rows.

    - #### setCHorzBands

          @Internal
          public void setCHorzBands(short field_78_cHorzBands)

      Size of each horizontal style band, in number of rows.

    - #### getCVertBands

          @Internal
          public short getCVertBands()

      Size of a vertical style band, in number of columns.

    - #### setCVertBands

          @Internal
          public void setCVertBands(short field_79_cVertBands)

      Size of a vertical style band, in number of columns.

    - #### getRgbrcInsideDefault_0

          @Internal
          public BorderCode getRgbrcInsideDefault_0()

      Border definition for inside horizontal borders.

    - #### setRgbrcInsideDefault_0

          @Internal
          public void setRgbrcInsideDefault_0(BorderCode field_80_rgbrcInsideDefault_0)

      Border definition for inside horizontal borders.

    - #### getRgbrcInsideDefault_1

          @Internal
          public BorderCode getRgbrcInsideDefault_1()

      Border definition for inside vertical borders.

    - #### setRgbrcInsideDefault_1

          @Internal
          public void setRgbrcInsideDefault_1(BorderCode field_81_rgbrcInsideDefault_1)

      Border definition for inside vertical borders.

    - #### setFAutofit

          @Internal
          public void setFAutofit(boolean value)

      Sets the fAutofit field value. When set to 1, AutoFit this table

    - #### isFAutofit

          @Internal
          public boolean isFAutofit()

      When set to 1, AutoFit this table
      Returns:
        the fAutofit field value.

    - #### setFKeepFollow

          @Internal
          public void setFKeepFollow(boolean value)

      Sets the fKeepFollow field value. When set to 1, keep this row with the following row

    - #### isFKeepFollow

          @Internal
          public boolean isFKeepFollow()

      When set to 1, keep this row with the following row
      Returns:
        the fKeepFollow field value.

    - #### setFtsWidth

          @Internal
          public void setFtsWidth(byte value)

      Sets the ftsWidth field value. Units for wWidth: 0 -- null; 1 -- auto, ignores wWidth, 2 -- percentage (in 50ths of a percent), 3 -- twips

    - #### getFtsWidth

          @Internal
          public byte getFtsWidth()

      Units for wWidth: 0 -- null; 1 -- auto, ignores wWidth, 2 -- percentage (in 50ths of a percent), 3 -- twips
      Returns:
        the ftsWidth field value.

    - #### setFtsWidthIndent

          @Internal
          public void setFtsWidthIndent(byte value)

      Sets the ftsWidthIndent field value. Units for wWidthIndent: 0 -- null; 1 -- auto, ignores wWidthIndent, 2 -- percentage (in 50ths of a percent), 3 -- twips

    - #### getFtsWidthIndent

          @Internal
          public byte getFtsWidthIndent()

      Units for wWidthIndent: 0 -- null; 1 -- auto, ignores wWidthIndent, 2 -- percentage (in 50ths of a percent), 3 -- twips
      Returns:
        the ftsWidthIndent field value.

    - #### setFtsWidthBefore

          @Internal
          public void setFtsWidthBefore(byte value)

      Sets the ftsWidthBefore field value. Units for wWidthBefore: 0 -- null; 1 -- auto, ignores wWidthBefore, 2 -- percentage (in 50ths of a percent), 3 -- twips

    - #### getFtsWidthBefore

          @Internal
          public byte getFtsWidthBefore()

      Units for wWidthBefore: 0 -- null; 1 -- auto, ignores wWidthBefore, 2 -- percentage (in 50ths of a percent), 3 -- twips
      Returns:
        the ftsWidthBefore field value.

    - #### setFtsWidthAfter

          @Internal
          public void setFtsWidthAfter(byte value)

      Sets the ftsWidthAfter field value. Units for wWidthAfter: 0 -- null; 1 -- auto, ignores wWidthAfter, 2 -- percentage (in 50ths of a percent), 3 -- twips

    - #### getFtsWidthAfter

          @Internal
          public byte getFtsWidthAfter()

      Units for wWidthAfter: 0 -- null; 1 -- auto, ignores wWidthAfter, 2 -- percentage (in 50ths of a percent), 3 -- twips
      Returns:
        the ftsWidthAfter field value.

    - #### setFNeverBeenAutofit

          @Internal
          public void setFNeverBeenAutofit(boolean value)

      Sets the fNeverBeenAutofit field value. When 1, table has never been autofit

    - #### isFNeverBeenAutofit

          @Internal
          public boolean isFNeverBeenAutofit()

      When 1, table has never been autofit
      Returns:
        the fNeverBeenAutofit field value.

    - #### setFInvalAutofit

          @Internal
          public void setFInvalAutofit(boolean value)

      Sets the fInvalAutofit field value. When 1, TAP is still valid, but autofit properties aren't

    - #### isFInvalAutofit

          @Internal
          public boolean isFInvalAutofit()

      When 1, TAP is still valid, but autofit properties aren't
      Returns:
        the fInvalAutofit field value.

    - #### setWidthAndFitsFlags_empty1

          @Internal
          public void setWidthAndFitsFlags_empty1(byte value)

      Sets the widthAndFitsFlags_empty1 field value. Not used

    - #### getWidthAndFitsFlags_empty1

          @Internal
          public byte getWidthAndFitsFlags_empty1()

      Not used
      Returns:
        the widthAndFitsFlags_empty1 field value.

    - #### setFVert

          @Internal
          public void setFVert(boolean value)

      Sets the fVert field value. When 1, positioned in vertical text flow

    - #### isFVert

          @Internal
          public boolean isFVert()

      When 1, positioned in vertical text flow
      Returns:
        the fVert field value.

    - #### setPcVert

          @Internal
          public void setPcVert(byte value)

      Sets the pcVert field value. Vertical position code. Specifies coordinate frame to use when paragraphs are absolutely positioned. 0 -- vertical position coordinates are relative to margin; 1 -- coordinates are relative to page; 2 -- coordinates are relative to text. This means: relative to where the next non-APO text would have been placed if this APO did not exist.

    - #### getPcVert

          @Internal
          public byte getPcVert()

      Vertical position code. Specifies coordinate frame to use when paragraphs are absolutely positioned. 0 -- vertical position coordinates are relative to margin; 1 -- coordinates are relative to page; 2 -- coordinates are relative to text. This means: relative to where the next non-APO text would have been placed if this APO did not exist.
      Returns:
        the pcVert field value.

    - #### setPcHorz

          @Internal
          public void setPcHorz(byte value)

      Sets the pcHorz field value. Horizontal position code. Specifies coordinate frame to use when paragraphs are absolutely positioned. 0 -- horizontal position coordinates are relative to column; 1 -- coordinates are relative to margin; 2 -- coordinates are relative to page

    - #### getPcHorz

          @Internal
          public byte getPcHorz()

      Horizontal position code. Specifies coordinate frame to use when paragraphs are absolutely positioned. 0 -- horizontal position coordinates are relative to column; 1 -- coordinates are relative to margin; 2 -- coordinates are relative to page
      Returns:
        the pcHorz field value.

    - #### setWidthAndFitsFlags_empty2

          @Internal
          public void setWidthAndFitsFlags_empty2(short value)

      Sets the widthAndFitsFlags_empty2 field value. Not used

    - #### getWidthAndFitsFlags_empty2

          @Internal
          public short getWidthAndFitsFlags_empty2()

      Not used
      Returns:
        the widthAndFitsFlags_empty2 field value.

    - #### setFFirstRow

          @Internal
          public void setFFirstRow(boolean value)

      Sets the fFirstRow field value. Used internally by Word: first row

    - #### isFFirstRow

          @Internal
          public boolean isFFirstRow()

      Used internally by Word: first row
      Returns:
        the fFirstRow field value.

    - #### setFLastRow

          @Internal
          public void setFLastRow(boolean value)

      Sets the fLastRow field value. Used internally by Word: last row

    - #### isFLastRow

          @Internal
          public boolean isFLastRow()

      Used internally by Word: last row
      Returns:
        the fLastRow field value.

    - #### setFOutline

          @Internal
          public void setFOutline(boolean value)

      Sets the fOutline field value. Used internally by Word: row was cached for outline mode

    - #### isFOutline

          @Internal
          public boolean isFOutline()

      Used internally by Word: row was cached for outline mode
      Returns:
        the fOutline field value.

    - #### setFOrigWordTableRules

          @Internal
          public void setFOrigWordTableRules(boolean value)

      Sets the fOrigWordTableRules field value. Used internally by Word: table combining like Word 5.x for the Macintosh and WinWord 1.x

    - #### isFOrigWordTableRules

          @Internal
          public boolean isFOrigWordTableRules()

      Used internally by Word: table combining like Word 5.x for the Macintosh and WinWord 1.x
      Returns:
        the fOrigWordTableRules field value.

    - #### setFCellSpacing

          @Internal
          public void setFCellSpacing(boolean value)

      Sets the fCellSpacing field value. Used internally by Word: When set to 1 cell spacing is allowed

    - #### isFCellSpacing

          @Internal
          public boolean isFCellSpacing()

      Used internally by Word: When set to 1 cell spacing is allowed
      Returns:
        the fCellSpacing field value.

    - #### setGrpfTap_unused

          @Internal
          public void setGrpfTap_unused(short value)

      Sets the grpfTap_unused field value. Not used

    - #### getGrpfTap_unused

          @Internal
          public short getGrpfTap_unused()

      Not used
      Returns:
        the grpfTap_unused field value.

    - #### setFWrapToWwd

          @Internal
          public void setFWrapToWwd(boolean value)

      Sets the fWrapToWwd field value. Used internally by Word: Wrap to window is on when set to 1

    - #### isFWrapToWwd

          @Internal
          public boolean isFWrapToWwd()

      Used internally by Word: Wrap to window is on when set to 1
      Returns:
        the fWrapToWwd field value.

    - #### setFNotPageView

          @Internal
          public void setFNotPageView(boolean value)

      Sets the fNotPageView field value. Used internally by Word: when set to 1 we are not in Page View

    - #### isFNotPageView

          @Internal
          public boolean isFNotPageView()

      Used internally by Word: when set to 1 we are not in Page View
      Returns:
        the fNotPageView field value.

    - #### setViewFlags_unused1

          @Internal
          public void setViewFlags_unused1(boolean value)

      Sets the viewFlags_unused1 field value. Not used

    - #### isViewFlags_unused1

          @Internal
          public boolean isViewFlags_unused1()

      Not used
      Returns:
        the viewFlags_unused1 field value.

    - #### setFWebView

          @Internal
          public void setFWebView(boolean value)

      Sets the fWebView field value. Used internally by Word: Web View is on when set to 1

    - #### isFWebView

          @Internal
          public boolean isFWebView()

      Used internally by Word: Web View is on when set to 1
      Returns:
        the fWebView field value.

    - #### setFAdjusted

          @Internal
          public void setFAdjusted(boolean value)

      Sets the fAdjusted field value. Used internally by Word

    - #### isFAdjusted

          @Internal
          public boolean isFAdjusted()

      Used internally by Word
      Returns:
        the fAdjusted field value.

    - #### setViewFlags_unused2

          @Internal
          public void setViewFlags_unused2(short value)

      Sets the viewFlags_unused2 field value. Not used

    - #### getViewFlags_unused2

          @Internal
          public short getViewFlags_unused2()

      Not used
      Returns:
        the viewFlags_unused2 field value.

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.